const txReportServant = require("tx-report-servant")

const Base = require('./Base');
const Tars = require("@tars/rpc")
const TarsServer = Tars.server
const Endpoint = require('@tars/utils').Endpoint

class App extends Base {
  async main({ impMap, configPath }) {
    const cfgPath = process.env.TARS_CONFIG || configPath;

    const servantConfigs = TarsServer.getServant(cfgPath)
    for (let i = 0; i < servantConfigs.length; i++) {
      const servantConfig = servantConfigs[i]
      const svr = TarsServer.createServer(impMap[servantConfig.servant]);
      svr.start(servantConfig);

      this.logger.info(`server ${servantConfig.servant} run in ${servantConfig.endpoint}`);
      // 从servantConfig.endpoint中解析出ip:port
      const endpoint = Endpoint.parse(servantConfig.endpoint)

      if (!process.env.TAF_CONFIG) {
        txReportServant.updateServant(servantConfig.servant, endpoint.iPort)
      }
    }
  }
}

module.exports = App;